/* Tabela de conteúdos
- Definições
- Estilos base
- Grid
- Tipografia
- Links
- Navbar
- Botões
- Formulários
- Listas
- Código
- Tabelas
- Espaçamentos
- Utilidades
- Media regras
*/

/* Definições
------------------------------------------------- */

:root {
  /* Cores */
  --blue: #007bff;
  --indigo: #6610f2;
  --purple: #6f42c1;
  --pink: #e83e8c;
  --red: #dc3545;
  --orange: #fd7e14;
  --yellow: #ffc107;
  --green: #28a745;
  --teal: #20c997;
  --cyan: #17a2b8;
  --white: #fff;
  --gray: #6c757d;
  --gray-dark: #343a40;
  --light: #f8f9fa;
  --dark: #343a40;

  --cor-fonte-base: #555;
  --cor-fonte-elemento-colorido: #ffffffde;
  --cor-selecao-elemento-colorido: #4e4e4e;
  --cor-fundo-base: #cfcaca;
  --cor-borda-base: #cfcccc;
  --cor-borda-input: #999;
  --cor-link: #337ab7;
  --cor-link-focus: #23527c;
  --cor-link-visitado: #c34f4a;
  --cor-processo: #0f98d8;
  --cor-sucesso: #00b36e;
  --cor-perigo: #e54e4e;
  --cor-alerta: #ff973d;
  --cor-table-hover: #e7f8fc;
  --cor-placeholder: #a8a4a4;
  --cor-sidebar: #383838;

  /* Estilos base */
  --espessura-fonte-base: 400;
  --espessura-fonte-negrito: 700;
  --bg-color-base: var(--cor-fundo-base);
  --border-base: var(--cor-borda-base);
  --border-radius-base: 0.7rem;
  --box-shadow-base: 0 2px 4px 0 rgba(0, 0, 0, 0.2),
    2px 0 3px 0 rgba(0, 0, 0, 0.19);
  --cor-base: var(--cor-fonte-base);
  --font-family-base: 'Avenir', 'Open Sans', Helvetica, Arial, sans-serif;
  --font-size-base: 1.3rem;
  --height-base: 2.5rem;
  --line-height-base: 1.15;
  --padding-base: 0 1rem;

  /* Grid */
  --bg-color-box: #fff;
  --padding-grid: 0.5rem;
  --padding-negativo-grid: -0.5rem;

  /* Responsividade */
  --width-mobile: 98%;
  --width-desktop: 98%;

  --right-hamburger: 3rem;

  /* Tipografia */
  --margin-header: 1.5rem 0;

  /* Botões */
  --box-shadow-botao-padrao: 0 8px 16px 0 rgba(0, 0, 0, 0.2),
    0 6px 20px 0 rgba(0, 0, 0, 0.19);
  --cor-botao-colorido: var(--cor-fonte-elemento-colorido);
  --cor-botao-padrao: var(--cor-fonte-base);
  --opacity-botao-padrao: 0.5;

  /* Botão processo */
  --bg-color-botao-processo: var(--cor-processo);

  /* Botão sucesso */
  --bg-color-botao-sucesso: var(--cor-sucesso);

  /* Botão perigo */
  --bg-color-botao-perigo: var(--cor-perigo);

  /* Botão alerta */
  --bg-color-botao-alerta: var(--cor-alerta);

  /* Formulários */
  --bg-color-input: #fff;

  --font-size-select: 0.8rem;
  --line-height-select: 26px;

  /* Espaçamentos */
  --margin-bottom-label: 0.5rem;
}

/* Estilos base
------------------------------------------------- */

*,
*::before,
*::after {
  box-sizing: border-box;
}

/* regra: 1em = 12pt = 16px = 100% */
html {
  font-size: 62.5%; /* reduz proporcionalmente 16px para 10px */
}

body {
  background-color: var(--bg-color-base);
  color: var(--cor-base);
  font-family: var(--font-family-base);
  font-size: var(--font-size-base);
  font-weight: var(--espessura-fonte-base);
  line-height: var(--line-height-base);
  margin: 0;
}

article,
aside,
dialog,
figcaption,
figure,
footer,
header,
hgroup,
main,
nav,
section {
  display: block;
}

/* Grid
------------------------------------------------- */
/* conteúdo só pode ser adicionado na coluna ou container nunca na linha */

.container {
  max-width: 100%;
  padding-left: var(--padding-grid);
  padding-right: var(--padding-grid);
  width: 100%;
}

.painel {
  background-color: var(--bg-color-box);
  border: 1px solid var(--border-base);
  border-radius: var(--border-radius-base);
  padding: 0.8rem 0.8rem 0;
}

.agrupamento {
  align-items: center;
  border: 1px solid var(--border-base);
  border-radius: var(--border-radius-base);
  display: flex;
  flex-wrap: wrap;
  justify-content: space-around;
  margin-bottom: 1rem;
  min-height: calc(var(--height-base) - 0.2rem);
}

.agrupamento.quebra {
  justify-content: flex-start;
}

.agrupamento.quebra label {
  padding: 0.5rem;
}

.agrupamento input,
.agrupamento label {
  margin: 0;
}

.linha {
  align-items: flex-end;
  display: flex;
  flex-wrap: wrap;
  margin-left: var(--padding-negativo-grid);
  margin-right: var(--padding-negativo-grid);
}

.linha .acima {
  align-items: flex-start;
}

.coluna,
.colunas {
  padding-left: var(--padding-grid);
  padding-right: var(--padding-grid);
  width: 100%;
}

/* Tipografia
------------------------------------------------- */

h1,
h2,
h3,
h4,
h5,
h6,
strong {
  font-weight: var(--espessura-fonte-negrito);
}

h1,
h2,
h3,
h4,
h5,
h6 {
  margin: var(--margin-header);
}

h1 {
  font-size: 4rem;
}

h2 {
  font-size: 3.4rem;
}

h3 {
  font-size: 2.8rem;
}

h4 {
  font-size: 2.2rem;
}

h5 {
  font-size: 1.6rem;
}

h6 {
  font-size: 1.4rem;
}

p {
  margin-top: 0;
}

/* Links
------------------------------------------------- */

a {
  color: var(--cor-link);
  cursor: pointer;
  text-decoration: none;
}

a:hover,
a:focus {
  color: var(--cor-link-focus);
}

a:visited {
  color: var(--cor-link-visitado);
}

/* Navbar
------------------------------------------------- */

.navbar-toggle,
.label-toggle {
  display: none;
}

.navbar ul {
  background: var(--cor-sidebar);
  height: 0;
  list-style: none;
  margin: 0;
  position: relative;
  visibility: hidden;
}

.navbar ul ul {
  padding: 0;
}

.navbar ul a,
.navbar ul span {
  color: var(--cor-fonte-elemento-colorido);
  display: block;
  padding: 1rem;
}

.navbar li {
  margin: 0;
  border-top: 1px solid var(--border-base);
}

.navbar ul li:hover {
  background: var(--cor-selecao-elemento-colorido);
  z-index: 999;
}

.navbar ul li ul li a,
.navbar ul li ul li span {
  padding-left: 3rem;
}

.navbar ul li ul li ul li a,
.navbar ul li ul li ul li span {
  padding-left: 5rem;
}

.label-toggle {
  background: var(--cor-sidebar);
  color: var(--cor-fonte-elemento-colorido);
  cursor: pointer;
  display: block;
  height: calc(var(--height-base) + 1.4rem);
  margin: 0;
  padding: 1.3rem 2rem;
}

.label-toggle:after {
  content: '\2261';
  font-size: calc(var(--font-size-base) + 1.1rem);
  position: absolute;
  right: var(--right-hamburger);
  margin-top: -0.7rem;
  padding: 0;
}

.navbar-toggle:checked ~ ul,
.navbar-toggle:checked ~ ul li ul {
  display: flex;
  flex-direction: column;
  height: auto;
  visibility: visible;
  z-index: 999;
}

/* Botóes
------------------------------------------------- */

.botao,
button,
input[type='submit'],
input[type='reset'],
input[type='button'] {
  background-color: var(--bg-color-base);
  border: 1px solid var(--border-base);
  border-radius: var(--border-radius-base);
  color: var(--cor-botao-padrao);
  cursor: default;
  display: inline-block;
  font-size: var(--font-size-base);
  height: var(--height-base);
  line-height: var(--height-base);
  padding: 0 1.7rem;
  text-align: center;
  text-decoration: none;
}

.botao:hover,
button:hover,
input[type='submit']:hover,
input[type='reset']:hover,
input[type='button']:hover {
  box-shadow: var(--box-shadow-botao-padrao);
}

.botao:focus,
button:focus,
input[type='submit']:focus,
input[type='reset']:focus,
input[type='button']:focus {
  box-shadow: var(--box-shadow-botao-padrao);
  outline: 0;
}

.botao:active,
button:active,
input[type='submit']:active,
input[type='reset']:active,
input[type='button']:active {
  opacity: var(--opacity-botao-padrao);
}

.botao.processo,
button.botao.processo,
input[type='submit'].botao.processo,
input[type='reset'].botao.processo,
input[type='button'].botao.processo {
  background-color: var(--bg-color-botao-processo);
  color: var(--cor-botao-colorido);
}

.botao.sucesso,
button.botao.sucesso,
input[type='submit'].botao.sucesso,
input[type='reset'].botao.sucesso,
input[type='button'].botao.sucesso {
  background-color: var(--bg-color-botao-sucesso);
  color: var(--cor-botao-colorido);
}

.botao.perigo,
button.botao.perigo,
input[type='submit'].botao.perigo,
input[type='reset'].botao.perigo,
input[type='button'].botao.perigo {
  background-color: var(--bg-color-botao-perigo);
  color: var(--cor-botao-colorido);
}

.botao.alerta,
button.botao.alerta,
input[type='submit'].botao.alerta,
input[type='reset'].botao.alerta,
input[type='button'].botao.alerta {
  background-color: var(--bg-color-botao-alerta);
  color: var(--cor-botao-colorido);
}

.botao:visited {
  color: var(--cor-botao-padrao);
}

.botao.processo:visited {
  color: var(--cor-botao-colorido);
}

.botao.sucesso:visited {
  color: var(--cor-botao-colorido);
}

.botao.perigo:visited {
  color: var(--cor-botao-colorido);
}

.botao.alerta:visited {
  color: var(--cor-botao-colorido);
}

/* Formulários
------------------------------------------------- */

input[type='email'],
input[type='number'],
input[type='search'],
input[type='text'],
input[type='tel'],
input[type='url'],
input[type='password'],
textarea,
select {
  background-color: var(--bg-color-input);
  border: 1px solid var(--border-base);
  border-radius: var(--border-radius-base);
  box-shadow: none;
  font: inherit;
  height: var(--height-base);
  padding: var(--padding-base);
}

input[type='email']:focus,
input[type='number']:focus,
input[type='search']:focus,
input[type='text']:focus,
input[type='tel']:focus,
input[type='url']:focus,
input[type='password']:focus,
textarea:focus,
select:focus {
  box-shadow: var(--box-shadow-base);
  outline: 0;
}

input[type='number'] {
  -moz-appearance: textfield;
}

input[type='number']::-webkit-inner-spin-button,
input[type='number']::-webkit-outer-spin-button {
  -webkit-appearance: none;
  margin: 0;
}

textarea::placeholder,
input::placeholder {
  color: var(--cor-placeholder);
}

select:-moz-focusring {
  color: transparent;
  text-shadow: 0 0 0 #000;
}

.select {
  position: relative;
  display: inline-block;
}

.select select {
  display: inline-block;
  outline: none;

  -webkit-appearance: none;
  -moz-appearance: none;

  -webkit-border-radius: var(--border-radius-base);
  -moz-border-radius: var(--border-radius-base);
  border-radius: var(--border-radius-base);
  width: 100%;
}

.select:after {
  content: '▼';
  font-size: var(--font-size-select);
  position: absolute;
  top: 0;
  right: 0;
  bottom: 0;
  line-height: var(--line-height-select);
  padding: var(--padding-base);
  color: var(--cor-botao-padrao);

  pointer-events: none;

  -webkit-border-radius: var(--border-radius-base);
  -moz-border-radius: var(--border-radius-base);
  border-radius: var(--border-radius-base);
}

.no-pointer-events .select:after {
  content: none;
}

textarea {
  min-height: 6.5rem;
}

label {
  display: block;
  margin-left: 0.3rem;
}

input[type='radio'] {
  -webkit-appearance: none;
  -moz-appearance: none;
  appearance: none;

  border-radius: 50%;
  width: calc(var(--font-size-base) - 0.2rem);
  height: calc(var(--font-size-base) - 0.2rem);

  border: 1px solid var(--cor-borda-input);
  transition: 0.2s all linear;
  outline: none;

  position: relative;
  top: 1px;
}

input[type='radio']:checked {
  border: 4px solid var(--cor-borda-input);
}

/* Listas
------------------------------------------------- */

ol,
ul {
  list-style-position: inside;
  padding-left: 0;
}

ul ul,
ul ol,
ol ol,
ol ul {
  margin-top: 1rem;
  padding-left: 3rem;
}

li {
  margin-bottom: 1rem;
}

/* Código
------------------------------------------------- */

code {
  background-color: var(--bg-color-base);
  border-radius: var(--border-radius-base);
  color: var(--cor-perigo);
  padding: 0.2rem 0.5rem;
}

pre > code {
  display: block;
  padding: 1rem 1.5rem;
}

/* Tabelas
------------------------------------------------- */

table {
  border-collapse: collapse;
}

.zebrada tbody tr:nth-child(odd) {
  background-color: var(--bg-color-base);
}

.realcada tbody:hover td[rowspan],
.realcada tr:hover td {
  background: var(--cor-table-hover);
}

th,
td {
  border-bottom: 1px solid var(--border-base);
  padding: 0.6rem;
  text-align: left;
}

/* Espaçamento
------------------------------------------------- */

.botao,
button,
input,
select,
textarea,
table {
  margin-bottom: 1rem;
}

label {
  margin-bottom: var(--margin-bottom-label);
}

.direita.botao,
.direita button,
.direita input[type='submit'],
.direita input[type='reset'],
.direita input[type='button'],
.centro.botao,
.centro button,
.centro input[type='submit'],
.centro input[type='reset'],
.centro input[type='button'] {
  margin-right: 0.3rem;
}

.colunas.centro {
  padding: 0;
}

.colunas.direita {
  padding: 0;
}

/* Utilidades
------------------------------------------------- */

.fluido {
  width: 100%;
}

.direita {
  display: flex;
  justify-content: flex-end;
}

.centro {
  display: flex;
  justify-content: center;
}

.justifica {
  display: flex;
  justify-content: space-between;
}

.justifica input {
  margin-bottom: 0;
}

.texto.direita {
  text-align: right;
}

.texto.centro {
  text-align: center;
}

/* Media regras
------------------------------------------------- */

/* tablets e desktops médios = 648px */
@media screen and (min-width: 40.5em) {
  /* Grid
  ------------------------------------------------- */

  .container {
    width: var(--width-desktop);
  }

  .uma.coluna,
  .uma.colunas {
    flex: 0 0 8.33333333%;
    max-width: 8.33333333%;
  }

  .duas.colunas {
    flex: 0 0 16.66666667%;
    max-width: 16.66666667%;
  }

  .tres.colunas {
    flex: 0 0 25%;
    max-width: 25%;
  }

  .quatro.colunas {
    flex: 0 0 33.33333333%;
    max-width: 33.33333333%;
  }

  .cinco.colunas {
    flex: 0 0 41.66666667%;
    max-width: 41.66666667%;
  }

  .seis.colunas {
    flex: 0 0 50%;
    max-width: 50%;
  }

  .sete.colunas {
    flex: 0 0 58.33333333%;
    max-width: 58.33333333%;
  }

  .oito.colunas {
    flex: 0 0 66.66666667%;
    max-width: 66.66666667%;
  }

  .nove.colunas {
    flex: 0 0 75%;
    max-width: 75%;
  }

  .dez.colunas {
    flex: 0 0 83.33333333%;
    max-width: 83.33333333%;
  }

  .onze.colunas {
    flex: 0 0 91.66666667%;
    max-width: 91.66666667%;
  }

  .doze.colunas {
    flex: 0 0 100%;
    max-width: 100%;
  }

  /* Navbar
  ------------------------------------------------- */

  .navbar ul {
    display: flex;
    flex-direction: row;
    justify-content: flex-start;
    height: auto;
    visibility: visible;
  }

  .navbar > ul > li > a,
  .navbar > ul > li > span {
    padding: 1rem;
  }

  .navbar ul li {
    border: 0;
    margin: 0;
    position: relative;
  }

  .navbar ul span {
    cursor: pointer;
  }

  .navbar ul ul:last-child a,
  .navbar ul ul:last-child span {
    padding-left: 1.5rem;
  }

  .navbar ul ul {
    display: none;
    padding: 0;
    position: absolute;
    width: 20rem;
  }

  .navbar ul ul ul {
    left: 100%;
    top: -0.1rem;
  }

  .navbar ul li:hover > ul {
    display: block;
  }

  .navbar li li {
    border-top: 1px solid var(--border-base);
  }

  .navbar i + i {
    float: right;
    margin: 0.1rem;
  }

  .label-toggle {
    display: none;
  }

  .navbar-toggle:checked ~ ul {
    flex-direction: row;
    height: auto;
    visibility: visible;
  }

  .navbar-toggle:checked ~ ul li ul {
    height: 0;
    visibility: hidden;
  }
}

/* celulares ou tablets menores = 460px */
@media screen and (min-width: 28.75em) {
  /* Grid
  ------------------------------------------------- */

  .container {
    margin: 0 auto;
    width: var(--width-mobile);
  }
}
